<?php
namespace Teknisa\Model\Teknisa\Repositories;

class OmConfigColeta extends \Doctrine\ORM\EntityRepository {

    public function findConfigColeta($conditions, $nrProdutoId){
        $query = <<<SQL
		SELECT OC.ID, OC.IDATIVO, OC.QTD_DIAS_REAPLICAR, OC.DT_LIMITE, OC.NRPRODUTO_ID, OC.NMPRODUTO, OC.NRORG_ID, OT.PHP_SCRIPT_LOG
          FROM (SELECT ID, IDATIVO, QTD_DIAS_REAPLICAR, DT_LIMITE, NRPRODUTO_ID, NMPRODUTO,
                       (SELECT RTRIM(XMLAGG(XMLELEMENT(E, OCCO.NRORG_ID, ',').EXTRACT('//text()') ORDER BY OCCO.NRORG_ID).GETCLOBVAL(), ',')
                         FROM OM_CONFIG_COLETA_ORG OCCO
                        WHERE OCCO.NRCONFCOL_ID = A.ID) AS NRORG_ID
                  FROM (SELECT ID, IDATIVO, QTD_DIAS_REAPLICAR, DT_LIMITE, NRPRODUTO_ID, NMPRODUTO, NRORG_ID
		                  FROM (SELECT OCC.ID, OCC.IDATIVO, OCC.QTD_DIAS_REAPLICAR, TO_CHAR(OCC.DT_LIMITE, 'DD/MM/YYYY') AS DT_LIMITE,
                                       OCC.NRPRODUTO_ID, OMP.NMPRODUTO, OCO.NRORG_ID
                                  FROM OM_CONFIG_COLETA OCC
                             LEFT JOIN OM_PRODUTO OMP ON OMP.ID = OCC.NRPRODUTO_ID
                             LEFT JOIN OM_CONFIG_COLETA_ORG OCO ON OCO.NRCONFCOL_ID = OCC.ID
                                 WHERE OCC.NRPRODUTO_ID = :NRPRODUTO_ID)
		     WHERE 1=1
		     $conditions) A
        GROUP BY ID, IDATIVO, QTD_DIAS_REAPLICAR, DT_LIMITE, NRPRODUTO_ID, NMPRODUTO) OC
       JOIN OM_CONFIG_COLETA OT ON OT.ID = OC.ID
SQL;
        $param = array( 'NRPRODUTO_ID' => $nrProdutoId );
        $registers = $this->getEntityManager()->getConnection()->fetchAll($query, $param);
        foreach($registers as &$register){
            $register['ID'] = intval($register['ID']);
            $register['NRORG_ID'] = explode(',', $register['NRORG_ID']);
        }
        return $registers;
    }


    private function getPaginatedQuery($query, $limit, $offset) {
        if ($limit > 0) {
            $max = $offset + $limit;
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $max . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $max;
            }
        }

        return $query;
    }
}