import { Loader, Metadata } from '@zeedhi/core';
import { TekGrid, TekGridColumn } from '@zeedhi/teknisa-components-common';
import { DataSourceController } from '../DataSourceController';

export class DSDataVisualization {
    private mainController: DataSourceController = Loader.getInstance("DataSourceController");

    private get datasourceData() {
        return this.mainController.datasourceData;
    }

    public updateDataVisualization() {
        // Se grid não foi montado, não faz nada
        if (Metadata.getInstances("dataVisualization-grid").length === 0 || !Metadata.getInstances("dataVisualization-grid")[0]) {
            return;
        }
        const dataSourceId = this.datasourceData._id;
        const dataGrid = Metadata.getInstance<TekGrid>("dataVisualization-grid");
        this.generateColumns();
        dataGrid.datasource.setFilter({ dataSourceId });
    }

    public generateColumns() {
        const columns = this.datasourceData.columns;
        const dataGrid = Metadata.getInstance<TekGrid>("dataVisualization-grid");
        dataGrid.columns = columns.map((column: any) => (new TekGridColumn({name: column.name, label: column.label, sortable: column.isSortable}, dataGrid)));
    }
}
